# TDD PHP

This sample project helps you to get started with TDD in PHP
# FizzBuzz

## Problem Description

Write a program that prints the numbers from 1 to 100. But for multiples of three print `Fizz` instead of the number and for the multiples of five print `Buzz`. For numbers which are multiples of both three and five print `FizzBuzz`.

Sample output:

```
1
2
Fizz
4
Buzz
Fizz
7
8
Fizz
Buzz
11
Fizz
13
14
FizzBuzz
16
17
Fizz
19
Buzz
... etc up to 100
```

## Rules

### First Rule

You can not write production code until you have written a failing unit test.

### Second Rule

You can not write more of an unit test than is sufficient to fail, and not compiling is a failing.

### Third Rule

You can not write more production code than is sufficient to pass the currently failing test.

## TDD loop

* **Red** : make a failing test case;
* **Green** : make the test pass;
* **Refactoring** : improve the design of your code
    * Duplication
    * Variables/Methods names not clear
    * Code hard to understand
    * etc.

![TDD Loop](./red-green-refactor.jpg)


## Getting Started

These instructions will get you a copy of the project up and running on your local machine for development and testing purposes.

### Prerequisites

Required software

```
PHP
Composer 
```
Composer: https://getcomposer.org/download/
### Installing

Install dependencies

```
composer install
```
Don't forget to rerun this command after adding new files

## Running the tests


### IDE

### Commandline

Execute in root of the project

### Mac ###

```
./vendor/bin/phpunit --bootstrap vendor/autoload.php tests/TestsShouldGoHere.php
```

### Windows ###

```
"vendor/bin/phpunit" --bootstrap ./vendor/autoload.php ./tests/TestsShouldGoHere.php
```

## Built With

* [Composer](https://getcomposer.org/) - Dependency Management
* [PHPUnit](https://phpunit.de/index.html) - Unit testing framework
